// ConfServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "afxctl.h"
#include <string>

#include "ConfServer.h"
#include "ConfServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int ID_TIMER1 = 100;
CConfServerDlg* gDialog = NULL;

using namespace std; 

BEGIN_DISPATCH_MAP(CConferenceServerEventSink, CCmdTarget)
//{{AFX_DISPATCH_MAP(CConferenceServerEventSink)
	DISP_FUNCTION_ID(CConferenceServerEventSink, "OnClientConnect", 202, OnClientConnect, VT_EMPTY, VTS_I4)
	DISP_FUNCTION_ID(CConferenceServerEventSink, "OnClientDisconnect", 203, OnClientDisconnect, VT_EMPTY, VTS_I4)
	DISP_FUNCTION_ID(CConferenceServerEventSink, "OnReceiveText", 201, OnReceiveText, VT_EMPTY, VTS_I4 VTS_BSTR)
//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CConferenceServerEventSink, CCmdTarget)
	INTERFACE_PART(CConferenceServerEventSink, IID_IConferenceServerEventSink, Dispatch)
END_INTERFACE_MAP()

CConferenceServerEventSink::CConferenceServerEventSink()
{
	EnableAutomation();
}

void CConferenceServerEventSink::OnClientConnect(long ConnId)
{
	HWND pWnd = GetDlgItem(m_DialogHWND, IDC_EDIT5);
	LockWindowUpdate(pWnd);

	long len = GetWindowTextLength(pWnd);
	char* buffer = new char[len + 1];
	GetWindowText(pWnd, buffer, len + 1);

	char id[5];
	itoa(ConnId, id, 10);

	string ip((gDialog->m_Conf)->GetClientParam(ConnId, cpIpAddress));
	string port((gDialog->m_Conf)->GetClientParam(ConnId, cpPort));
	string msg(string(buffer) + "connected (id=" + id + "; ip=" + ip + "; port=" + port + ")\r\n");

	BOOL res = SetWindowText(pWnd, msg.c_str());

	delete [] buffer;
	LockWindowUpdate(NULL);
	(gDialog->m_Log).SetSel(msg.length(), msg.length(), FALSE);
	(gDialog->m_Log).RedrawWindow();
}

void CConferenceServerEventSink::OnClientDisconnect(long ConnId)
{
	/*
	HWND pWnd = GetDlgItem(m_DialogHWND, IDC_EDIT5);
	LockWindowUpdate(pWnd);

	long len = GetWindowTextLength(pWnd);

	char* buffer = new char[len + 1];
	GetWindowText(pWnd, buffer, len + 1);	 

	char id[5];
	itoa(ConnId, id, 10);
	string msg(string(buffer) + "disconnected (id=" + id + ")\r\n");

	BOOL res = SetWindowText(pWnd, msg.c_str());

	delete [] buffer;
	LockWindowUpdate(NULL);

	(gDialog->m_Log).SetSel(msg.length(), msg.length(), FALSE);
	(gDialog->m_Log).RedrawWindow();
	*/
}

void CConferenceServerEventSink::OnReceiveText(long ConnId, BSTR text)
{
	char* msg = (char*) text;

	int i, id;
	for (i = 0; i <= (gDialog->m_Conf)->ClientCount - 1; i++)
	{
		id = (gDialog->m_Conf)->GetClientConnId(i);
		if (id != ConnId) (gDialog->m_Conf)->SendText(id, msg); //don't resend to author
	}
}

/////////////////////////////////////////////////////////////////////////////
// CConfServerDlg dialog

CConfServerDlg::CConfServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfServerDlg)
	m_ServerPort = _T("");
	m_Clients = _T("");
	m_LogStr = _T("");
	m_ClientId = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CConfServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfServerDlg)
	DDX_Control(pDX, IDC_EDIT5, m_Log);
	DDX_Control(pDX, IDC_COMBO3, m_ServerSamplingRate);
	DDX_Control(pDX, IDC_COMBO1, m_ServerSocketType);
	DDX_Control(pDX, IDC_BUTTON2, m_ServerStop);
	DDX_Control(pDX, IDC_BUTTON1, m_ServerStart);
	DDX_Text(pDX, IDC_EDIT1, m_ServerPort);
	DDX_Text(pDX, IDC_EDIT4, m_Clients);
	DDX_Text(pDX, IDC_EDIT5, m_LogStr);
	DDX_Text(pDX, IDC_EDIT7, m_ClientId);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CConfServerDlg, CDialog)
	//{{AFX_MSG_MAP(CConfServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfServerDlg message handlers

BOOL CConfServerDlg::OnInitDialog()
{
	gDialog = this;
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ServerSocketType.AddString(_T("TCP"));
	m_ServerSocketType.AddString(_T("UDP"));
	m_ServerSocketType.SetCurSel(1);

	m_ServerSamplingRate.AddString(_T("8000"));
	m_ServerSamplingRate.AddString(_T("44100"));
	m_ServerSamplingRate.SetCurSel(0);

	m_ServerPort = _T("17820");

	m_ClientId = _T("ClientId");

	UpdateData(false);
	VCInit();

	SetTimer(ID_TIMER1, 500, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CConfServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CConfServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CConfServerDlg::OnClose() 
{
	KillTimer(ID_TIMER1);
	VCUninit();	
	CDialog::OnClose();
}

void CConfServerDlg::VCInit()
{
	m_Conf.CreateInstanceLic(_uuidof(vcproConferenceServerX), L"0");
	
	// specify wich ACM codec to use (49 = GSM)
	m_Conf->FormatTag = 49;
	m_Conf->PcmNumChannels = 1;
	m_Conf->PcmSamplesPerSec = 44100;
	m_Conf->PcmBitsPerSample = 16;

	m_ServerSink.m_DialogHWND = m_hWnd;
	m_pUnkSink = m_ServerSink.GetIDispatch(FALSE);
	BOOL res = AfxConnectionAdvise(m_Conf, IID_IConferenceServerEventSink, m_pUnkSink, FALSE,
		&m_dwCookie);
}

void CConfServerDlg::VCUninit()
{
	AfxConnectionUnadvise(m_Conf, IID_IConferenceServerEventSink, m_pUnkSink, FALSE,
		m_dwCookie);

	ServerInit(false);
}

void CConfServerDlg::ServerInit(bool bStart)
{
	if (bStart) {
		UpdateData();
		BSTR port = m_ServerPort.AllocSysString();
		m_Conf->Port = port;
		SysFreeString(port);

		m_Conf->Proto = static_cast<unaProtoType>(m_ServerSocketType.GetCurSel());

		m_Conf->PcmSamplesPerSec = SamplingRate(m_ServerSamplingRate);
	}

	m_Conf->Active = bStart;
}

int CConfServerDlg::SamplingRate(CComboBox& combo) {

	switch (combo.GetCurSel()) {
		case 1: return 44100;
		default: return 8000;
	}
}

void CConfServerDlg::OnButton1() { ServerInit(); }

void CConfServerDlg::OnButton2() { ServerInit(false); }

void CConfServerDlg::OnTimer(UINT nIDEvent)
{
	int serverActive = m_Conf->Active;

	m_ServerStart.EnableWindow(!serverActive);
	m_ServerStop.EnableWindow(serverActive);

	m_Clients.Format(_T("%d/%d"), m_Conf->ClientCount, m_Conf->MaxClients);
	CWnd*pWnd = GetDlgItem(IDC_EDIT4);
	pWnd->SetWindowText(m_Clients);

	char buffer[10];
	itoa(m_Conf->BytesReceived, buffer, 10);
	string serverSizeIn(string("bytes received: ") + string(buffer));
	itoa(m_Conf->BytesSent, buffer, 10);
	string serverSizeOut(string("bytes sent: ") + string(buffer));

	pWnd = GetDlgItem(IDC_STATIC1);
	pWnd->SetWindowText(serverSizeIn.c_str());
	pWnd = GetDlgItem(IDC_STATIC2);
	pWnd->SetWindowText(serverSizeOut.c_str());

	pWnd = GetDlgItem(IDC_STATIC_ACTIVE);
	if (serverActive) pWnd->SetWindowText("active");
	else pWnd->SetWindowText("not active");

	CDialog::OnTimer(nIDEvent);
}

void CConfServerDlg::OnButton7() 
{
	char buffer[10];
	CWnd* pWnd = GetDlgItem(IDC_EDIT7);
	pWnd->GetWindowText(buffer, sizeof(buffer));
	m_Conf->DisconnectClient(atoi(buffer));
}
